﻿/**
 * 用於描述事件的物件的基礎類別。
 * EventObject實體將被傳給實作
 * EventListener的類別所定義的事件方法。 
 * 每一種事件類型都應該透過EventObject子類別來呈現。 
 *
 * 每個EventObject實體都儲存了它自己的事件來源的參考，
 * 也就是參考到產生事件的那個物件。
 */
class event.EventObject {
  // 事件的來源
  private var source:Object;

  /**
   * 建構子
   *
   * @param   src   事件的來源
   */
  public function EventObject (src:Object) {
    source = src;
  }
  
  /**
   * 傳回事件的來源
   */
  public function getSource (  ):Object {
    return source;
  }
}