﻿import util.*;

/**
 * 建立佈滿星星的夜空，並偵聽Randomizer
 * 的事件來建立隨機的流星。
 */
class nightsky.NightSky implements RandomizerListener {
  // 建立夜空的影片片段 
  private var target:MovieClip;
  // 夜空影片片段 
  private var sky_mc:MovieClip;
  // 在建立夜空的影片片段（target裡的深度值，預設為0。
  private var skyDepth:Number = 0;
  // 在建立流星的影片片段（sky_mc）裡的深度值，預設為0。 
  private var starDepth:Number = 0;
 
  /**
   * 建構子
   */
  public function NightSky (target:MovieClip, 
                            skyDepth:Number, starDepth:Number) {
    this.target = target;
    this.skyDepth = skyDepth;
    this.starDepth = starDepth;
    makeSkyBG(  );
  }

  /**
   * 回應從Randomizer物件傳來的隨機事件。
   * 在夜空中建立流星。
   * 
   * @param   e   描述此事件的物件
   */
  public function onRandomAction (e:RandomizerEvent):Void {
    trace("新流星！上次流星出現所經過的時間："
          + e.getTimeSinceLast(  ));
    makeShootingStar(  );
  }

  /**
   * 透過附加連結名稱為"skybg" 的影片片段， 
   * 來建立星空的圖像。
   */
  private function makeSkyBG (  ):Void {
    sky_mc = target.attachMovie("skybg", "skybg", skyDepth);
  }
  
  /**
   * 透過附加連結名稱為"shootingstar" 的影片片段， 
   * 來產生流星效果。
   */
  private function makeShootingStar (  ):Void {
    // Create the shooting star in the sky movie clip.
    sky_mc.attachMovie("shootingstar", 
                       "shootingstar" + starDepth, starDepth);
    // Randomly position the shooting star.
    sky_mc["shootingstar" + starDepth]._x = Math.floor(Math.random(  ) 
                                            * target.skybg._width);
    sky_mc["shootingstar" + starDepth]._y = Math.floor(Math.random(  ) 
                                            * target.skybg._height);
    // 把下一個流星放在高一點的深度
    starDepth++;
  }
}