﻿import event.*;
import util.*;

/**
 *   描述Randomizer事件的事件物件
 */
class util.RandomizerEvent extends EventObject {
  // 自上次事件被廣播後，所經過的毫秒數。
  private var timeSinceLast:Number;

  /**
   * 建構子
   *
   * @param  src   			事件來源（一個Randomizer實體）
   * @param  timeSinceLast	自上次事件後所經過的毫秒數。
   */
  public function RandomizerEvent (src:Randomizer, timeSinceLast:Number) {
    // 記得總是要傳遞事件來源給父類別的建構子！
    super(src);

    // 記錄自上次事件後所經過的毫秒數。
    this.timeSinceLast = timeSinceLast;
  }

  /**
   * 傳回自上次事件後所經過的毫秒數。
   */
  public function getTimeSinceLast (  ):Number {
    return timeSinceLast;
  }
}